<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-list-item
    :key="item.data"
    @click="$emit('selected', item)"
  >
    <v-list-item-avatar>
      <v-icon v-if="item.active" class="ACTIVE">mdi-clock-outline</v-icon>
      <v-icon v-else class="PAUSED">mdi-clock-outline</v-icon>
    </v-list-item-avatar>
    <v-list-item-content>
      <v-list-item-title>
        {{item.name || item.id}}
        <template v-if="false">
          <v-icon small v-if="sharing=='private'">mdi-lock</v-icon>
          <v-icon small v-if="sharing=='public'">mdi-earth</v-icon>
          <v-icon small v-if="sharing=='shared'">mdi-share-variant</v-icon>
        </template>
      </v-list-item-title>
      <v-list-item-subtitle>
        {{item.description}}
      </v-list-item-subtitle>
      
      <v-list-item-subtitle>
        <div v-if="this.item.provider && this.item.provider.name">Provider is: <b>{{(this.item.provider && this.item.provider.name)}}</b></div>
        <div v-else>Provider is: <v-icon x-small color="orange">mdi-alert</v-icon> No provider info available for this schedule (you might not have sufficient permissions for this)</div>        
        
        <div>Benchmarked resources are: <b>{{resources.join(', ')}}</b></div>
        
        <template v-if="workloadNames && workloadNames.length>0">
          <div>Workloads are: <b>{{workloadNames.join(', ')}}</b></div>
        </template>
        
        <div v-if="item.active">
          This schedule is <span style="color:green; font-weight:bold">ACTIVE</span> and runs every <b>{{interval}} {{unit}}</b>.
        </div>
        <div v-else>
          This schedule is <span style="color:orange; font-weight:bold">PAUSED</span>. It would run every <b>{{interval}} {{unit}}</b>.
        </div>
        <div class="id">Id: {{item.id}}</div>
      </v-list-item-subtitle>
    </v-list-item-content>
  </v-list-item>
  
</template>

<script>

import { getScheduleSharingLevel } from '../common/benchsuite.js';

export default {

 name: 'ScheduleSummary',

  components: {
  },

  props: {
    item: {
      type: Object,
      default: function() {return {}}
    }
  },
  
  data: () => ({
  }),
  
  computed: {
    sharing() {
      return getScheduleSharingLevel(this.item);
    },
    interval() {
      if(this.item && this.item.scheduling_hints.interval)
        for(var i in this.item.scheduling_hints.interval)
          return this.item.scheduling_hints.interval[i];
      return ""
    },
    unit() {
      if(this.item && this.item.scheduling_hints.interval)
        for(var i in this.item.scheduling_hints.interval)
          return i;
      return ""
    },
    workloadNames() {
      var out = [];
      for(var i in this.item.workloads) {
        out.push(this.item.workloads[i].workload_name + " (" + this.item.workloads[i].tool_name + ")");      
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    },
    resources() {
      var res = {}
      for(var i in this.item.service_types) {
        var st = this.item.service_types[i] ;
        if(!res[st.image])
          res[st.image] = [];
        res[st.image].push(st.size);
      }
      var out = []
      for(var k in res) {
        out.push(k + " (" + res[k].join(", ") + ")");
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    }
  }
};

</script>

<style>
  div.id {
    font-size:0.9em;
    padding-top:2px;
  }
  i.v-icon.v-icon.ACTIVE {
    color: green;
    background: #e0ffe0;
  }
  i.v-icon.v-icon.PAUSED {
  }
</style>